#ifndef _ALFABETA_
#define _ALFABETA_

#include "misc.h"
#include "bitboards.h"

#define INFTY 1000000
#define KINGTAKEN 500000
#define MAXNODE 1
#define MINNODE 2

int maxval(int a, int b);
int minval(int a, int b);

/*-----------------------------------------------------
 | The following constants are used in alphabeta() to |
 | determine which moves should be pruned as futile.  |
 -----------------------------------------------------*/
#define FUTILITY_PRUNING_MARGIN 400
#define EXT_FUTILITY_PRUNING_MARGIN 700
#define RAZOR_MARGIN 1000

/*------------------------------------------------------
 | The following constant determines to how many ply   |
 | the is_draw_by_repetition() function should be used |
 | for checking draws by repetition. This function     |
 | is more accurate than checking draws by repetition  |
 | in the hashtable, but also a lot slower.            |
 ------------------------------------------------------*/
#define MOVE2HISTORY_REPETITION_PLY 5

int compare_boards(struct board *board1, struct board *board2);

int perft(struct board *board, int alpha, int beta, int depth, int ply);

int quiescence(struct board *board, int alpha, int beta, int ply, int depth);

int material_gain(struct board *board, struct move_new *move);

int alphabeta(struct board *board, int alpha, int beta, int depth,
	      int null_ok, int ply, int threat,
	      int white_checks, int black_checks, int pv);

#endif       //_ALFABETA_

